QGIS Application - Bug report #4426
Add a number_format() function to the QgsExpression
2011-10-22 03:45 AM - Mathieu Pellerin - nIRV

Status: Closed

Priority: Normal

Assignee: Nathan Woodrow

Category: Map Canvas

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution: fixed
Crashes QGIS or corrupls data: Copied to github as #: 14358
Description

It'd be very useful for have a number_format() function to allow formatting of numbers with grouped thousands. For example,
number_format(12846) would result in the string '12,846'.

This function could come in very handy when used with the geometry values offered by the expression based labeling engine. For
example, you could have nicely formatted area or length numbers by simply doing number_format($area) / number_format($length).

History

#1 - 2011-10-24 10:37 PM - Alister Hood

This would be an important feature. In the meantime you might be able to achieve what you need using something like this, although it isn't a particularly
sustainable (~=fast and easy) solution:
regexp_replace( toint($area) ,'(\Wd+)(\Wd{3})","\\\\1,\\\\2")

EDIT - there seems to be some bug which stops that exact expression from working (it works OK in the expression based labels window's preview, but no
labels are drawn on the canvas), although it works as part of a larger expression.

#2 - 2011-10-24 10:41 PM - Alister Hood
- File rounding_in_labels.PNG added

Also note that there is a "formatted numbers" section in the main labelling dialogue under "label settings", and:

1) It is a bit out of place there, as all the other options relate to label format rather than label content. Maybe it should be removed, superseded by the
expression based labelling.

2) It has a "show plus sign" option, which currently has no equivalent in the expression based label dialogue (although | guess you could achieve it with
regexp_replace).

3) Rather than reimplementing the "decimal places" option along with the thousands separator as part of number_format(), it might be best to implement a
separate round() function, which would be more generally useful in the field calculator. It is already possible to round if you need to though - e.g. | rounded
to 2 d.p. in the attached screenshot.

#3 - 2011-10-24 10:52 PM - Nathan Woodrow
- Subject changed from Add a number_format() function to the expression based labeling engine to Add a number_format() function to the

QgsExpression

Just changed the header as it's more related to the expression parser itself rather than the labeling per sa
#4 - 2011-11-04 01:49 PM - Alister Hood

Alister Hood wrote:

EDIT - there seems to be some bug which stops that exact expression from working (it works OK in the expression based labels window's preview,

but no labels are drawn on the canvas), although it works as part of a larger expression.

Should be fixed now (everything seemed to work when | tried Nathan's patch on #4495)

#5 - 2011-11-04 11:42 PM - Mathieu Pellerin - nIRV

Alister, the expression above only adds one thousands separator, it's not recursive.

I.E. the number 12345 properly transforms into 12,345 but the number 12345678 ends up 12345,678.

#6 - 2011-11-05 06:22 PM - Alister Hood

Yes, that's why | said "might" and "something like this".

#7 - 2011-12-16 02:10 PM - Giovanni Manghi
- Target version set to Version 1.7.4

#8 - 2012-04-16 06:31 AM - Paolo Cavallini

- Target version changed from Version 1.7.4 to Version 1.8.0
- Crashes QGIS or corrupts data set to No

- Affected QGIS version set to master

#9 - 2012-06-01 04:37 PM - Martin Dobias

There are several things to consider:
- locale (defines decimal character, group separator character and group separation rules)
- number of decimal places
- leading zeros

- scientific notation
It seems there is no common way for doing that across existing SQL engines:
MySQL: format(number, decimal_places [, locale])
PostgreSQL, Oracle: to_char(number, format)
Ms SQL: str(number, output_length, decimal_places)
#10 - 2012-07-24 12:40 AM - Mathieu Pellerin - nIRV

Nathan, loving all of the new functions you've recently added in the expression builder. The CASE / CASE ELSE addition is pure magic.

That said, | was wondering whether this bug is on your expression builder improvements agenda. Working with large numbers representing concession
areas, the decimal formatting is a must for people to quickly read whether concession is in the thousands or tens of thousands of hectares.

Wish | could add the feature myself : /
#11 - 2012-09-04 11:56 AM - Paolo Cavallini

- Target version changed from Version 1.8.0 to Version 2.0.0

#12 - 2012-09-04 06:37 PM - Mathieu Pellerin - nIRV

The function was added by NathanW in this commit
https://issues.qgis.org/projects/quantum-gis/repository/revisions/fbfa025485369b12d1dd33f60bfa7d6802ac369d

Leaving NathanW with the honor of marking this bug closed -> fixed :)

That said, | have one little comment on the way this was implemented. | think the function should allow for a custom separator character to be defined.
Relying on system locale setting for the separator can be problematic and is limiting in nature.

NathanW, thanks! :)
#13 - 2012-09-04 11:54 PM - Paolo Cavallini
- Resolution set to fixed

- Status changed from Open to Closed

Files

rounding_in_labels.PNG 3.26 KB 2011-10-24 Alister Hood
